<?php
namespace Kaomoji;

use Concrete\Core\Editor\Plugin;
use Concrete\Core\Asset\AssetList;

class Kaomoji
{
    protected $app;

    protected $_plugins = [];

    protected $_editorType;

    protected function getPluginsToInstall()
    {
        return ['kaomoji' => t('Kaomojis (Japanese emojis)')];
    }

    public function ActivatePlugins()
    {
        $editor = app()->make('editor');
        $this->_editorType = get_Class($editor);

        if (strpos($this->_editorType, 'Ckeditor')) {
            $pluginManager = $editor->getPluginManager();
            $plugins = $this->getPluginsToInstall();

            foreach ($plugins as $pluginHandle => $pluginName) {
                $plugin = $this->getPlugin($pluginHandle, $pluginName);
                if (!$pluginManager->isAvailable($plugin)) {
                    // [NOUR] this puts the plugin in the list of available plugins
                    // it still needs to be selected
                    $pluginManager->register($plugin, $pluginName);
                }
                if (!$pluginManager->isSelected($plugin)) {
                    // enable the plugin !!!!!
                    // [NOUR] this selects (enables) the plugin putting it in the list of selected plugins
                    // this is what makes the checkbox be checked in the list of plugins in the dashboard
                    $key = $plugin->getKey();
                    $pluginManager->select($key);
                }
            }
        } else {
            return false;
        }
    }

    /**
     */
    protected function getPlugin($pluginHandle, $pluginName)
    {
        $plugin = null;

        if (!isset($this->_plugins[$pluginHandle]) || !$this->_plugins[$pluginHandle] || !is_object($this->_plugins[$pluginHandle])) {  // no need to do this again for next editor
            $options = null;
            $al = AssetList::getInstance();
            if (strpos($this->_editorType, 'Ckeditor')) {
                $al->register(
                    'javascript',
                    'editor/ckeditor4/' . $pluginHandle,
                    'js/plugins/' . $pluginHandle . '/register.js',
                    [],
                    'ckeditor_kaomoji'
                );
                $al->registerGroup('editor/ckeditor4/' . $pluginHandle, [
                    ['javascript', 'editor/ckeditor4/' . $pluginHandle]
                ]);

                $plugin = new Plugin();
                $plugin->setKey($pluginHandle);
                $plugin->setName($pluginName);
                $plugin->requireAsset('editor/ckeditor4/' . $pluginHandle);
            }

            $this->_plugins[$pluginHandle] = $plugin;
        }

        return $plugin;
    }
}
